/* Prompt.c generated by valac 0.48.6, the Vala compiler
 * generated from Prompt.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Canonical Ltd
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <gtk/gtk.h>
#include <glib.h>
#include "deja.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

void prompt (GtkApplication* app);
void show_prompt_notification (GtkApplication* app);
gchar* get_header (void);
gchar* get_body (void);
gchar* get_cancel_button (gboolean mnemonics);
gchar* get_ok_button (gboolean mnemonics);

void
prompt (GtkApplication* app)
{
	g_return_if_fail (app != NULL);
	deja_dup_update_prompt_time (FALSE);
	show_prompt_notification (app);
}

gchar*
get_header (void)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup (_ ("Keep your files safe by backing up regularly"));
	result = _tmp0_;
	return result;
}

gchar*
get_body (void)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup (_ ("Important documents, data, and settings can be protected by storing " "them in a backup. In the case of a disaster, you would be able to reco" \
"ver " "them from that backup."));
	result = _tmp0_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
get_cancel_button (gboolean mnemonics)
{
	gchar* rv = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup (_ ("_Don't Show Again"));
	rv = _tmp0_;
	if (!mnemonics) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = rv;
		_tmp2_ = string_replace (_tmp1_, "_", "");
		_g_free0 (rv);
		rv = _tmp2_;
	}
	result = rv;
	return result;
}

gchar*
get_ok_button (gboolean mnemonics)
{
	gchar* rv = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup (_ ("_Open Backup Settings"));
	rv = _tmp0_;
	if (!mnemonics) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = rv;
		_tmp2_ = string_replace (_tmp1_, "_", "");
		_g_free0 (rv);
		rv = _tmp2_;
	}
	result = rv;
	return result;
}

void
show_prompt_notification (GtkApplication* app)
{
	GNotification* note = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GNotification* _tmp2_;
	GNotification* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GThemedIcon* _tmp6_;
	GThemedIcon* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_if_fail (app != NULL);
	_tmp0_ = get_header ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_notification_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	note = _tmp3_;
	_tmp4_ = get_body ();
	_tmp5_ = _tmp4_;
	g_notification_set_body (note, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (ICON_NAME);
	_tmp7_ = _tmp6_;
	g_notification_set_icon (note, (GIcon*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	g_notification_set_default_action (note, "app.prompt-ok");
	_tmp8_ = get_cancel_button (FALSE);
	_tmp9_ = _tmp8_;
	g_notification_add_button (note, _tmp9_, "app.prompt-cancel");
	_g_free0 (_tmp9_);
	_tmp10_ = get_ok_button (FALSE);
	_tmp11_ = _tmp10_;
	g_notification_add_button (note, _tmp11_, "app.prompt-ok");
	_g_free0 (_tmp11_);
	g_application_send_notification ((GApplication*) app, "prompt", note);
	_g_object_unref0 (note);
}

